#pragma once

#include <string>
#include <vector>

// NOTE: fwd dec of struct TTF_Font does NOT work
#include <SDL/SDL_ttf.h>

#include "../Graphics/FontSprite.h"

#include "../Arch/Singleton.h"

#include "../Components/FwdDecs.h"

namespace Input_
{

class CommandLine : public Singleton<CommandLine>
{
public:
	~CommandLine();

	void init();

	void appendToInputStr(const std::string& str);
	void setInputStr(const std::string& newInputStr);
	void readToInputStr(unsigned int c, bool state);

	void addLineToOutputBox(const std::string& str);
	void addLineToMsgBox(const std::string& str);
	void clearOutputBox();

	bool getActiveState(void);
	void setActiveState(bool as);

private:
	CommandLine();
	friend class Singleton<CommandLine>;

	void clearInputBox(void);
	void backspaceFromInputStr(void);
	void prevMsgToInputStr(void);
	void nextMsgToInputStr(void);
	void addToMsgBox(void);
	void parseLine(void);

	void fontInit(void);	
	TTF_Font *courier, *arial, *comic;

	std::vector<std::string>::iterator curMsg;

	Sprite_::FontSprite inputBox, msgBox, outputBox;

	bool isActive;
};

std::string subString(std::string::iterator& begin, std::string::iterator& end);
}
//END OF Input_
